#include <ctime>
#include <cstdlib>
#include <iostream>

void Untie();

int main() {
    srand(time(nullptr));
    Untie();
    int n;
    int q;
    int twos = 0;
    int drain;
    std::cin >> n;
    for (int i = 0; i < n; i++) {
        std::cin >> drain;
    }
    for (int i = 0; i < n - 1; i++) {
        std::cin >> drain >> drain;
    }
    std::cin >> q;
    for (int i = 0; i < q; i++) {
        std::cin >> drain;
        if (drain == 1) {
            std::cin >> drain >> drain;
        }
        else {
            twos++;
            std::cin >> drain >> drain >> drain;
        }
    }
    while (twos--) {
        std::cout << rand() % n << std::endl;
    }
    return 0;
}

void Untie() {
    std::ios_base::sync_with_stdio(false);
    std::cout.tie(nullptr);
    std::cerr.tie(nullptr);
    std::cin.tie(nullptr);
}